;; ----------globale und lokale Variabeln -------------
globals
[
  tick-delta                           ;; how much we advance the tick counter this time through
  max-tick-delta                       ;; the largest tick-delta is allowed to be
  box-size
  box-edge                             ;; distance of box edge from axes
  left-particles right-particles       ;; particles in the left and right chambers
  avg-speed-particles avg-energy-particles
  avg-epot-particles avg-ekin-particles
  fast medium slow                     ;; current counts
  edukte produkte
  masse
  breite-edukte
  n-edukte n-produkte
  energy-left energy-right
  q
  nachkommastellen
  q-nachkommastellen
  count-to-delete
  trace-particle
  edukt-partikel
  produkt-partikel
  y_particles_left
  y_particles_right
  Speed-initial
  n-mittelwerte
  edukte-mittel
  produkte-mittel
  q-mittel
  E-kin-fix
  E-tot-fix
  text
]

breed [ particles particle ]
breed [ flashes flash ]
flashes-own [birthday]

particles-own
[
  speed mass energy          ;; particle info
  last-collision
  step-size
  typus
  ekin
  epot
]

;; ------------------ setup --------------------------
to setup
  clear-all
  set Speed-initial 2
  if (preset != "manuell") [
    set Edukte-initial 50
    set Produkte-initial 0
  ]

  if (preset = "s niedrig heiss")[
    set Energieniveau-Edukte 10
    set Energieniveau-Produkte 20
    set Aktivierungsenergie-Top 25
    set Breite-Eduktniveau 0.5
    set Hoehe-initial 1
  ]
  if (preset = "s hoch heiss")[
    set Energieniveau-Edukte 10
    set Energieniveau-Produkte 50
    set Aktivierungsenergie-Top 55
    set Breite-Eduktniveau 0.5
    set Hoehe-initial 1
  ]
  if (preset = "s niedrig kalt")[
    set Energieniveau-Edukte 10
    set Energieniveau-Produkte 20
    set Aktivierungsenergie-Top 25
    set Breite-Eduktniveau 0.5
    set Hoehe-initial 0.3
  ]
  if (preset = "s hoch kalt")[
    set Energieniveau-Edukte 10
    set Energieniveau-Produkte 50
    set Aktivierungsenergie-Top 55
    set Breite-Eduktniveau 0.5
    set Hoehe-initial 0.3
    set Breite-Eduktniveau 0.5
  ]
  if (preset = "z niedrig heiss")[
    set Energieniveau-Edukte 20
    set Energieniveau-Produkte 10
    set Aktivierungsenergie-Top 25
    set Breite-Eduktniveau 0.5
    set Hoehe-initial 1
  ]
  if (preset = "z hoch heiss")[
    set Energieniveau-Edukte 50
    set Energieniveau-Produkte 10
    set Aktivierungsenergie-Top 55
    set Breite-Eduktniveau 0.5
    set Hoehe-initial 1
  ]
  if (preset = "z niedrig kalt")[
    set Energieniveau-Edukte 20
    set Energieniveau-Produkte 10
    set Aktivierungsenergie-Top 25
    set Hoehe-initial 0.3
    set Breite-Eduktniveau 0.5
  ]
  if (preset = "z hoch kalt")[
    set Energieniveau-Edukte 50
    set Energieniveau-Produkte 10
    set Aktivierungsenergie-Top 55
    set Hoehe-initial 0.3
  ]
  if (preset = "s entropisch links")[
    set Energieniveau-Edukte 10
    set Energieniveau-Produkte 20
    set Aktivierungsenergie-Top 25
    set Breite-Eduktniveau 0.8
  ]
  if (preset = "s entropisch rechts")[
    set Energieniveau-Edukte 10
    set Energieniveau-Produkte 20
    set Aktivierungsenergie-Top 25
    set Breite-Eduktniveau 0.2
  ]
  if (preset = "z entropisch links")[
    set Energieniveau-Edukte 20
    set Energieniveau-Produkte 10
    set Aktivierungsenergie-Top 25
    set Breite-Eduktniveau 0.8
  ]
  if (preset = "z entropisch rechts")[
    set Energieniveau-Edukte 20
    set Energieniveau-Produkte 10
    set Aktivierungsenergie-Top 25
    set Breite-Eduktniveau 0.2
  ]
  set E-kin-fix -1
  set E-tot-fix -1
  set energy-left Energieniveau-Edukte
  set energy-right Energieniveau-Produkte

  set n-edukte Edukte-initial
  set n-produkte Produkte-initial
  set-default-shape particles "circle"
  set-default-shape flashes "square"
  set nachkommastellen 1   ;; Energie
  set q-nachkommastellen 4
  set masse 1
  set box-size 100                    ;; könnte mit Slider reguliert werden
  set max-tick-delta 0.1073
  set box-edge (round (max-pxcor * box-size / 100) - 1)
  set breite-edukte (box-edge * 2 * Breite-Eduktniveau)
  set y_particles_right (2 * box-edge - (box-edge * 2 * energy-right / 100) - 2)
  set y_particles_left (2 * box-edge - (box-edge * 2 * energy-left / 100) - 2)
  make-particles
  make-box

  set trace-particle 0

  find-q
  mittelwerte-reset


  reset-ticks
end


to find-q
    carefully[
    set q (count particles with [ xcor > (- box-edge + breite-edukte)]) / (count particles with [ xcor < (- box-edge + breite-edukte)])
  ] [set q 0]
end


to mittelwerte-reset
  set n-mittelwerte 0
end


;; ------------------------Programm laufen lassen ------------------------------------------------------

to go
  ask particles [set step-size speed * tick-delta]
  ask particles [bounce]
  ask particles [ move ]
  ask particles
   [ if Kollisionen? [check-for-collision] ]
  ask particles [reaktion]
  ask particles [if Farbwechsel? [farbaenderung]]

  tick-advance tick-delta
  if floor ticks > floor (ticks - tick-delta)
  [
     update-variables
     update-plots
  ]
  calculate-tick-delta

  ask flashes with [ticks - birthday > 0.4]
    [ die ]

  ifelse (Spur?)
    [ ask particle trace-particle [ pen-down ] ]
    [ ask particle trace-particle [ pen-up ] ]

  find-q
  set edukte-mittel (((edukte-mittel * n-mittelwerte) + n-edukte) / (n-mittelwerte + 1))
  set produkte-mittel (((produkte-mittel * n-mittelwerte) + n-produkte) / (n-mittelwerte + 1))
  set q-mittel (((q-mittel * n-mittelwerte) + q) / (n-mittelwerte + 1))
  set n-mittelwerte (n-mittelwerte + 1)



  if (Energie-fixieren = "keine")[set E-kin-fix -1
    set E-tot-fix -1]

  if (Energie-fixieren = "E-kin")[
    ifelse (E-kin-fix = -1)[
      set E-tot-fix -1
      set E-kin-fix avg-ekin-particles
      print ((word "E-kin-fix " E-kin-fix) )
    ]
    [if ((avg-ekin-particles * 1) > E-kin-fix) [change-temperature 0.999]
      if ((avg-ekin-particles * 1) < E-kin-fix) [change-temperature 1.001]]
      ]

  if (Energie-fixieren = "E-total")[
    ifelse (E-tot-fix = -1)[set E-kin-fix -1
      set E-tot-fix avg-energy-particles
      print ((word "E-tot-fix " E-tot-fix) )
    ]
    [if (avg-energy-particles * 1 > E-tot-fix) [change-temperature 0.999]
      if (avg-energy-particles * 1 < E-tot-fix) [change-temperature 1.001]]
  ]




  display
end

;; ----------------------------- updates ---------------------------------------------
to hochruecken
  ask particles
  [
    if ((xcor < (- box-edge + breite-edukte)) and (ycor <  (- box-edge + box-edge * 2 * energy-left / 100))) [set ycor (- box-edge + box-edge * 2 * energy-left / 100 + 1) ]
    if ((xcor >= (- box-edge + breite-edukte)) and (ycor <  (- box-edge + box-edge * 2 * energy-right / 100))) [set ycor (- box-edge + box-edge * 2 * energy-right / 100 + 1) ]
  ]
end


to update
  set energy-left Energieniveau-Edukte
  set energy-right Energieniveau-Produkte
  ask patches with [pcolor = yellow] [set pcolor black]
  set breite-edukte (box-edge * 2 * Breite-Eduktniveau)
  make-box
  hochruecken
end

;; ----------------------------- Box zeichnen ---------------------------------------------
;; Box zeichnen
to make-box
  ask patches with [ ((abs pxcor = box-edge) and (abs pycor <= box-edge)) or
                     ((abs pycor = box-edge) and (abs pxcor <= box-edge)) or
                     ((pycor <= round(- box-edge + box-edge * 2 * Aktivierungsenergie-Top / 100)) and (abs pycor <= box-edge) and (pxcor = round(- box-edge + breite-edukte))) or
                     ((pycor <= round(- box-edge + box-edge * 2 * energy-left / 100)) and (abs pycor <= box-edge) and (pxcor <= round(- box-edge + breite-edukte) and (abs pxcor <= box-edge))) or
                     ((pycor <= round(- box-edge + box-edge * 2 * energy-right / 100)) and (abs pycor <= box-edge) and (pxcor >= round(- box-edge + breite-edukte) and (abs pxcor <= box-edge)))

  ]
    [ set pcolor yellow ]
end

;; ----------------------------- Partikel erstellen ---------------------------------------------
;; creates initial particles
to make-particles
  create-particles n-edukte [
    set speed Speed-initial
    set mass masse
    random-position-left
    set color cyan
    set typus "edukt"
  ]
  create-particles n-produkte [
    set speed Speed-initial
    set mass masse
    random-position-right
    set shape "circle"
    set color magenta
    set typus "produkt"
  ]

  set edukte particles with [color = cyan]
  set produkte particles with [color = magenta]
  ask particles
  [
    set ekin (0.5 * mass * speed * speed)
    set epot ((ycor + box-edge) * mass * Gravitationsbeschleunigung)
    set energy (ekin + epot)
    ;; make their graphical size equal to the cube root of their mass
    set size  mass ^ .33 * Partikel-Radius
    set last-collision nobody
    recolor
  ]
  calculate-tick-delta
end

to random-position-right ;; particle procedure
  setxy ((1 - box-edge) + round(breite-edukte) + random-float (round(2 * box-edge - breite-edukte) - 2))
        ((1 - box-edge + box-edge * 2 * energy-right / 100) + (Hoehe-initial * random-float (y_particles_right)))
end

to random-position-left ;; particle procedure
  setxy ((1 - box-edge) + random-float (round(breite-edukte) - 2))
        ((1 - box-edge + box-edge * 2 * energy-left / 100) + (Hoehe-initial * random-float (y_particles_left)))
        ;;((1 - box-edge) + random-float (2 * box-edge  - 2))
end



;; ----------------------------- Bewegung, Reflexion an Wand und anderen Partikeln  ---------------------------------------------
to calculate-tick-delta
  ;; tick-delta is calculated in such way that even the fastest
  ;; particle will jump at most 1 patch length in a tick. As
  ;; particles jump (speed * tick-delta) at every tick, making
  ;; tick length the inverse of the speed of the fastest particle
  ;; (1/max speed) assures that. Having each particle advance at most
  ;; one patch-length is necessary for it not to "jump over" a wall.
  ifelse any? particles with [speed > 0]
    [ set tick-delta min list (1 / (ceiling max [speed] of particles)) max-tick-delta ]
    [ set tick-delta max-tick-delta ]
end

to factor-gravity  ;; turtle procedure
  let vx (dx * speed)
  let vy (dy * speed) - (Gravitationsbeschleunigung * tick-delta)
  set speed sqrt ((vy ^ 2) + (vx ^ 2))
  recolor
  set heading atan vx vy
end

to move  ;; particle procedure
  if patch-ahead (speed * tick-delta) != patch-here
    [ set last-collision nobody ]
  ;;jump (speed * tick-delta)
  setxy (xcor + dx * speed * tick-delta)
        (ycor + dy * speed * tick-delta - Gravitationsbeschleunigung * (0.5 * tick-delta * tick-delta))
  factor-gravity
end

to update-variables
  ask particles
  [
    set ekin (0.5 * mass * speed * speed)
    set epot ((ycor + box-edge) * mass * Gravitationsbeschleunigung)
    set energy (ekin + epot)
  ]
  set avg-ekin-particles    mean [ekin] of particles
  set avg-speed-particles   mean [speed] of particles
  set avg-epot-particles    mean [epot] of particles
  set avg-energy-particles  mean [energy] of particles
  set n-edukte count particles with [ xcor <= (- box-edge + breite-edukte)]
  set n-produkte count particles with [ xcor > (- box-edge + breite-edukte)]
end

to bounce  ;; particle procedure
  ;; entwichene in die Mitte
  if ((abs pxcor = box-edge) or (abs pycor = box-edge))  [
    set xcor 0
    set ycor box-edge - 3
  ]

  ;; if we are already on a wall, no need for further checks
  if pcolor = yellow [stop]
  ;; get the coordinates of the patch we'll be on if we go forward 1
  let new-patch patch-ahead step-size
  let new-px [pxcor] of new-patch
  let new-py [pycor] of new-patch

  if [pcolor] of new-patch != yellow [ stop ]
  ;; if hitting left or right wall, reflect heading around x axis
  if abs new-px = box-edge [ set heading (- heading)]
  ;; if hitting top or bottom wall, reflect heading around y axis, wobei bottom-wall nicht exisitier
  if abs new-py = box-edge  [ set heading (180 - heading) ]

  ;; Reflexion an Böden
  if ((new-px < round(- box-edge + breite-edukte)) and (new-py <= round(- box-edge + box-edge * 2 * energy-left / 100)))
      [ set heading (180 - heading) ]

  if ((new-px > round(- box-edge + breite-edukte)) and (new-py <= round(- box-edge + box-edge * 2 * energy-right / 100)))
      [ set heading (180 - heading) ]

  ;; if hitting partition (Strich der Aktivierungsenergie), reflect heading around x axis unless near an opening
  if new-px = round(- box-edge + breite-edukte) [set heading ( - heading)
                if [pcolor] of patch-ahead step-size = yellow [set heading  (180 - heading)]]
 ;; create some flash turtles to show the bouncing particles
  ask patch new-px new-py
  [ sprout-flashes 1 [
      set color pcolor - 2
      set birthday ticks
    ]
  ]

  hochruecken
end


to check-for-collision  ;; particle procedure
  ;; Here we impose a rule that collisions only take place when there
  ;; are exactly two particles per patch.  We do this because when the
  ;; student introduces new particles from the side, we want them to
  ;; form a uniform wavefront.
  ;;
  ;; Why do we want a uniform wavefront?  Because it is actually more
  ;; realistic.  (And also because the curriculum uses the uniform
  ;; wavefront to help teach the relationship between particle collisions,
  ;; wall hits, and pressure.)
  ;;
  ;; Why is it realistic to assume a uniform wavefront?  Because in reality,
  ;; whether a collision takes place would depend on the actual headings
  ;; of the particles, not merely on their proximity.  Since the particles
  ;; in the wavefront have identical speeds and near-identical headings,
  ;; in reality they would not collide.  So even though the two-particles
  ;; rule is not itself realistic, it produces a realistic result.  Also,
  ;; unless the number of particles is extremely large, it is very rare
  ;; for three or more particles to land on the same patch (for example,
  ;; with 400 particles it happens less than 1% of the time).  So imposing
  ;; this additional rule should have only a negligible effect on the
  ;; aggregate behavior of the system.
  ;;
  ;; Why does this rule produce a uniform wavefront?  The particles all
  ;; start out on the same patch, which means that without the only-two
  ;; rule, they would all start colliding with each other immediately,
  ;; resulting in much random variation of speeds and headings.  With
  ;; the only-two rule, they are prevented from colliding with each other
  ;; until they have spread out a lot.  (And in fact, if you observe
  ;; the wavefront closely, you will see that it is not completely smooth,
  ;; because some collisions eventually do start occurring when it thins out while fanning.)

  if count other particles-here = 1
  [
    ;; the following conditions are imposed on collision candidates:
    ;;   1. they must have a lower who number than my own, because collision
    ;;      code is asymmetrical: it must always happen from the point of view
    ;;      of just one particle.
    ;;   2. they must not be the same particle that we last collided with on
    ;;      this patch, so that we have a chance to leave the patch after we've
    ;;      collided with someone.
    let candidate one-of other particles-here with
      [who < [who] of myself and myself != last-collision]
    ;; we also only collide if one of us has non-zero speed. It's useless
    ;; (and incorrect, actually) for two particles with zero speed to collide.
    if (candidate != nobody) and (speed > 0 or [speed] of candidate > 0)
    [
      collide-with candidate
      set last-collision candidate
      ask candidate [ set last-collision myself ]
    ]
  ]
end

;; implements a collision with another particle.
;;
;; THIS IS THE HEART OF THE PARTICLE SIMULATION, AND YOU ARE STRONGLY ADVISED
;; NOT TO CHANGE IT UNLESS YOU REALLY UNDERSTAND WHAT YOU'RE DOING!
;;
;; The two particles colliding are self and other-particle, and while the
;; collision is performed from the point of view of self, both particles are
;; modified to reflect its effects. This is somewhat complicated, so I'll
;; give a general outline here:
;;   1. Do initial setup, and determine the heading between particle centers
;;      (call it theta).
;;   2. Convert the representation of the velocity of each particle from
;;      speed/heading to a theta-based vector whose first component is the
;;      particle's speed along theta, and whose second component is the speed
;;      perpendicular to theta.
;;   3. Modify the velocity vectors to reflect the effects of the collision.
;;      This involves:
;;        a. computing the velocity of the center of mass of the whole system
;;           along direction theta
;;        b. updating the along-theta components of the two velocity vectors.
;;   4. Convert from the theta-based vector representation of velocity back to
;;      the usual speed/heading representation for each particle.
;;   5. Perform final cleanup and update derived quantities.

to collide-with [ other-particle ] ;; particle procedure
  ;;; PHASE 1: initial setup

  ;; for convenience, grab some quantities from other-particle
  let mass2 [mass] of other-particle
  let speed2 [speed] of other-particle
  let heading2 [heading] of other-particle

  ;; since particles are modeled as zero-size points, theta isn't meaningfully
  ;; defined. we can assign it randomly without affecting the model's outcome.
  let theta (random-float 360)



  ;;; PHASE 2: convert velocities to theta-based vector representation

  ;; now convert my velocity from speed/heading representation to components
  ;; along theta and perpendicular to theta
  let v1t (speed * cos (theta - heading))
  let v1l (speed * sin (theta - heading))

  ;; do the same for other-particle
  let v2t (speed2 * cos (theta - heading2))
  let v2l (speed2 * sin (theta - heading2))



  ;;; PHASE 3: manipulate vectors to implement collision

  ;; compute the velocity of the system's center of mass along theta
  let vcm (((mass * v1t) + (mass2 * v2t)) / (mass + mass2) )

  ;; now compute the new velocity for each particle along direction theta.
  ;; velocity perpendicular to theta is unaffected by a collision along theta,
  ;; so the next two lines actually implement the collision itself, in the
  ;; sense that the effects of the collision are exactly the following changes
  ;; in particle velocity.
  set v1t (2 * vcm - v1t)
  set v2t (2 * vcm - v2t)



  ;;; PHASE 4: convert back to normal speed/heading

  ;; now convert my velocity vector into my new speed and heading
  set speed sqrt ((v1t ^ 2) + (v1l ^ 2))
  ;;set energy (0.5 * mass * speed * speed)

  ;; if the magnitude of the velocity vector is 0, atan is undefined. but
  ;; speed will be 0, so heading is irrelevant anyway. therefore, in that
  ;; case we'll just leave it unmodified.
  if v1l != 0 or v1t != 0
    [ set heading (theta - (atan v1l v1t)) ]

  ;; and do the same for other-particle
  ask other-particle [
    set speed sqrt ((v2t ^ 2) + (v2l ^ 2))
    set ekin (0.5 * mass * (speed ^ 2))
    if v2l != 0 or v2t != 0
      [ set heading (theta - (atan v2l v2t)) ]
  ]

  ;; PHASE 5: final updates

  ;; now recolor, since color is based on quantities that may have changed
  recolor
  ask other-particle
    [ recolor ]
end

to reaktion
  if (xcor < (- box-edge + breite-edukte) and typus = "produkt") [set typus "edukt"]
  if (xcor > (- box-edge + breite-edukte) and typus = "edukt") [set typus "produkt"]
end



;; ----------------------- Farbanpassungen bei Seitenwechsel oder je nach Geschwindigkeit -------------------------

to farbaenderung ;; particle procedure
  if (typus = "edukt") [set color cyan]
  if (typus = "produkt") [set color magenta]
end

to recolor  ;; particle procedure
  carefully [
    let values [ speed ] of breed
    let lower-limit mean values - 3 * standard-deviation values
    let upper-limit mean values + 3 * standard-deviation values
    set color scale-color color speed (lower-limit - 1) (upper-limit + 1)
  ]
  [print "zu wenige Teilchen für Farbanpassung"]
end


;; ---------------------------------- Buttons: Aenderung der Temperatur oder der Teilchenzahl ---------------------------------

to change-temperature [a]  ;; a knapp unter 1 (kühlen) oder knapp über 1 (heizen)
  ask particles
  [
   set speed ((speed ^ 2) * a ) ^ 0.5
  ]
end

to plus-edukte
  create-particles 10 [
    set speed Speed-initial
    set mass masse
    random-position-left
    set color cyan
    set typus "edukt"
  ]
  set edukte particles with [typus = "edukt"]
  ask particles
  [
    set ekin (0.5 * mass * speed * speed)
    set epot ((ycor + box-edge) * mass * Gravitationsbeschleunigung)
    set energy (ekin + epot)
    ;; make their graphical size equal to the cube root of their mass
    set size  mass ^ .33 * Partikel-Radius
    set last-collision nobody
    recolor
  ]
  calculate-tick-delta
end

to plus-produkte
  create-particles 10 [
    set speed Speed-initial
    set mass masse
    random-position-right
    set color magenta
    set typus "produkt"
  ]
  set produkte particles with [typus = "produkt"]
  ask particles
  [
    set ekin (0.5 * mass * speed * speed)
    set epot ((ycor + box-edge) * mass * Gravitationsbeschleunigung)
    set energy (ekin + epot)
    ;; make their graphical size equal to the cube root of their mass
    set size  mass ^ .33 * Partikel-Radius
    set last-collision nobody
    recolor
  ]
  calculate-tick-delta
end

to minus-edukte
  set count-to-delete 10
  set edukt-partikel (particles with [typus = "edukt" and who > 0])   ;; partikel null darf nicht gelöscht werden, da sie trace macht
  set count-to-delete min list 10 count edukt-partikel
  ask n-of count-to-delete edukt-partikel [
    die
  ]
end

to minus-produkte
  set count-to-delete 10
  set edukt-partikel (particles with [typus = "produkt" and who > 0])   ;; partikel null darf nicht gelöscht werden, da sie trace macht
  set count-to-delete min list 10 count edukt-partikel
  ask n-of count-to-delete edukt-partikel [
    die
  ]
end
@#$#@#$#@
GRAPHICS-WINDOW
210
10
863
664
-1
-1
5.0
1
10
1
1
1
0
1
1
1
-64
64
-64
64
1
1
1
ticks
30.0

BUTTON
65
175
120
208
setup
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SLIDER
26
218
198
251
Energieniveau-Edukte
Energieniveau-Edukte
0
100
20.0
1
1
NIL
HORIZONTAL

SLIDER
26
255
198
288
Energieniveau-Produkte
Energieniveau-Produkte
0
100
10.0
1
1
NIL
HORIZONTAL

SLIDER
26
290
197
323
Aktivierungsenergie-Top
Aktivierungsenergie-Top
0
100
25.0
1
1
NIL
HORIZONTAL

SLIDER
26
326
198
359
Breite-Eduktniveau
Breite-Eduktniveau
0
1
0.5
0.01
1
NIL
HORIZONTAL

SLIDER
10
13
182
46
Edukte-initial
Edukte-initial
0
100
50.0
1
1
NIL
HORIZONTAL

SLIDER
10
50
182
83
Produkte-initial
Produkte-initial
0
100
0.0
1
1
NIL
HORIZONTAL

SLIDER
10
88
182
121
Hoehe-initial
Hoehe-initial
0
1
1.0
0.1
1
NIL
HORIZONTAL

BUTTON
127
175
182
208
NIL
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SWITCH
27
443
157
476
Kollisionen?
Kollisionen?
0
1
-1000

MONITOR
867
11
1006
56
Mittlere kinetische Energie
round(avg-ekin-particles * 10 ^ nachkommastellen) / 10 ^ nachkommastellen
17
1
11

PLOT
867
157
1276
393
Edukte und Produkte
ticks
Anzahl
0.0
100.0
0.0
100.0
true
true
"" ""
PENS
"Edukte" 1.0 0 -13345367 true "" "plotxy ticks count particles with [ xcor <= (- box-edge + breite-edukte)]"
"Produkte" 1.0 0 -955883 true "" "plotxy ticks count particles with [ xcor > (- box-edge + breite-edukte)]"

SWITCH
27
480
117
513
Spur?
Spur?
1
1
-1000

BUTTON
121
479
186
512
clear trace
clear-drawing
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
27
362
89
395
update
update
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SWITCH
26
405
157
438
Farbwechsel?
Farbwechsel?
0
1
-1000

SLIDER
27
517
190
550
Gravitationsbeschleunigung
Gravitationsbeschleunigung
0
30
15.0
1
1
NIL
HORIZONTAL

PLOT
869
399
1276
663
Q
Zeit
Q
0.0
10.0
0.0
1.0
true
true
"" ""
PENS
"Q" 1.0 0 -16777216 true "" "plotxy ticks q"

MONITOR
967
60
1062
105
Q aktuell
round(q  * 10 ^ q-nachkommastellen) / 10 ^ q-nachkommastellen
17
1
11

MONITOR
1009
10
1153
55
Mittlere potentielle Energie
round(avg-epot-particles * 10 ^ nachkommastellen) / 10 ^ nachkommastellen
17
1
11

MONITOR
1158
10
1287
55
Mittlere Energie
round(avg-energy-particles * 10 ^ nachkommastellen) / 10 ^ nachkommastellen
17
1
11

BUTTON
9
561
89
594
20% kühlen
change-temperature 0.8
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
94
561
170
594
20% heizen
change-temperature 1.2
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
10
597
88
630
+ 10 Edukte
plus-edukte
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
94
597
180
630
+ 10 Produkte
plus-produkte
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
8
632
88
665
- 10 Edukte
minus-edukte
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

MONITOR
867
59
963
104
n Teilchen
count(particles)
17
1
11

BUTTON
94
632
179
665
- 10 Produkte
minus-produkte
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

CHOOSER
10
125
102
170
preset
preset
"manuell" "z niedrig heiss" "z hoch heiss" "z niedrig kalt" "z hoch kalt" "s niedrig heiss" "s hoch heiss" "s niedrig kalt" "s hoch kalt" "z entropisch links" "z entropisch rechts" "s entropisch links" "s entropisch rechts"
0

MONITOR
1064
107
1157
152
Q mittel
round(q-mittel * 10 ^ q-nachkommastellen) / 10 ^ q-nachkommastellen
17
1
11

MONITOR
868
107
963
152
Edukte mittel
round(edukte-mittel * 10 ^ q-nachkommastellen) / 10 ^ q-nachkommastellen
17
1
11

MONITOR
967
108
1062
153
Produkte Mittel
round(produkte-mittel  * 10 ^ q-nachkommastellen) / 10 ^ q-nachkommastellen
17
1
11

BUTTON
1176
113
1270
146
reset Mittel
mittelwerte-reset
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

CHOOSER
1158
59
1287
104
Energie-fixieren
Energie-fixieren
"keine" "E-kin" "E-total"
0

CHOOSER
106
125
198
170
Partikel-Radius
Partikel-Radius
0.8 1 1.5 2 2.5 3
3

@#$#@#$#@
## WHAT IS IT?

Das physikalische Modell der jumping beans (oder hüpfender Atome) hilft, eine Reihe von Phänomenen auf der molekularen Ebene zu erkunden und zu verstehen. 

- Dynamisches Gleichgewicht
- Luftdruck (barometrische Höhenformel)
- Unter welchen Bedingungen läuft eine Reaktion vollständig und irreversibel ab?
- Verschiebungen von Gleichgewichtssystemen nach Le Chatelier durch Hinzufügen oder Entfernen von Reaktanden, durch Heizen oder Kühlen.
- weshalb laufen exotherme Reaktionen bevorzugt ab, und zwar besonders, wenn Energie an die Umgebung abgegeben wird. Was geschieht mit der Anzahl Realisierungsmöglichkeiten mit / ohne Energieabgabe.
- Bei welchen Einflüssen ändert sich die Gleichgewichtskonstante und bei welchen nicht?
- Der Einfluss der Energie, der Entropie und der Temperatur auf die Gleichgewichtslage. Dabei dient der Höhenunterschied als Analogie für potentielle Energieunterschiede auf mikroskopischer Ebene, was unter Umständen mit der Enthalpie gleichgesetzt werden kann. Die seitliche Ausdehnung jedes Energieniveaus dient als Mass für die Anzahl Realisierungsmöglichkeiten, was logarithmiert die Entropie ergäbe. Die kinetische Energie der Teilchen dient als Mass für die Temperatur. 
- Prozesse können adiabatisch geführt werden und dann wieder auf die ursprüngliche Temperatur gekühlt werden und der Unterschied veranschaulicht.  
- Wenn ein System im Gleichgewicht gekühlt wird, so nimmt nicht nur die kinetische Energie ab, sondern auch die potentielle (Hüpfhöhe) und zudem verschiebt sich das Gleichgewicht, wenn die Aktivierungsenergie nicht zu gross ist. Was also ist ein thermisches Gleichgewicht? Welche Freiheitsgrade sind daran beteiligt und welche nicht? Was ist der Unterschied zwischen Wärme und Temperatur?

- usw. usf.


## HOW IT WORKS

Vorbereitet wird die Simulation mit dem Button [setup], gestartet mit [go]. Mit den Sliders lassen sich vor dem Setup Einstellungen vornehmen, wobei die Sliders oberhalb des Setup-Knopfes nur vor dem Setup wirken, die anderen auch während der Simulation.
Mit Preset kann auch auf vordefinierte Einstellungen zurückgegriffen werden.
Die Abbildungen rechts zeigen die Anzahlen der Teilchen über dem linken bzw. rechten Energieniveau und den Reaktionskoeffizienten Q.

## HOW TO USE IT

- setup: Neustart mit neuen Einstellungen
- go: Simulation starten und pausieren
- Preset: 
	- "manuell": es werden die Einstellungen der Sliders übernommen
	- z bedeutet, dass die Edukte energetisch höher liegen, während mit 
	- s die Produkte höher liegen. 
	- Entropisch links bedeutet, dass die seitliche Ausdehnung der Edukte grösser ist, so dass es dort für ein gegebenes Teilchen mehr Realisierungsmöglichkeiten gibt.  

Bereich der y-Achse eines Plots kann in der Kommandozeile angepasst werden:

	set-current-plot "Edukte und Produkte" 
	set-plot-y-range 0 2

Dabei kann man auch mehrere Befehle in einer Zeile hintereinander schreiben:

	set-current-plot "Q" set-plot-y-range 0 2

Mit den Aufwärts- und Abwärtspfeilen können vorhergehende Befehle zurückgeholt werden.

Mit folgenden Befehlen kann ein Plot gelöscht und dann die Zeit auf Null gesetzt werden:

	set-current-plot "Edukte und Produkte" 
	reset-ticks
	clear-plot

In einer Zeile für beide Plots: 

	set-current-plot "Edukte und Produkte" clear-plot set-current-plot "Q" clear-plot reset-ticks

Druch den Befehl reset-ticks wird die Zeit wieder auf 0 gesetzt. Dadurch werden die Blitzchen, die beim der Kollision der Teilchen mit der Wand entstehen, eingefroren. Sie können entfernt werden mit

	ask flashes [set birthday 0]

Werte können vorgegeben werden mit set:

	set E-kin-fix 320

Alle Partikel können cyan gefärbt werden mit

	ask particles [set color cyan]


## THINGS TO NOTICE

- Spur?: Man für ein bestimmtes Teilchen die Spur einzeichnen lassen
- Farbwechsel?: Wenn dieser Schalter eingeschaltet wird, werden alle Teilchen beim Wechsel des Niveaus neu eingefärbt, so dass auf der Eduktseite alle Teilchen cyan gefärbt sind, auf der Produktseite alle magenta. Zudem verfärben sich die Teilchen je nach Geschwindigkeit, was sich allerdings nicht ausschalten lässt.

## THINGS TO TRY

Mögliche Fragestellungen: 

- Wann kann man in der Grafik die Gleichgewichtskonstante K ablesen?
- Wie wirken sich Heizen, Kühlen, Hinzufügen und Wegnehmen von Teilchen auf das Gleichgewicht bzw. die Gleichgewichtskonstante K aus?
- Suche einstellungen für eine Reaktion, so dass die Reaktion irreversibel ist und keine Rückreaktion festzustellen ist.
- Wie verändert sich der Luftdruck (das Teilchenverheltnis zwischen den Niveaus), wenn man den Höhenunterschied verdoppelt und vervierfacht?
- Suche Einstellungen für eine entropisch günstige aber energetisch ungünstige Reaktion, bei der das Gleichgewicht gerade etwa in der Mitte liegt, K also etwa 1 ist. 
- Wie kann es sein, dass in der heissen Kerzenflamme (im Gleichgewicht) elementarer Wasserstoff und Sauerstoff auftreten, in den Verbrennungsgasen dann aber nicht mehr?
- Schalte die Kollisionen aus und die Spur ein und überprüfe anhand der Spur, ob die Energieerhaltung gewährleistet ist, auch wenn das Teilchen das Niveau wechselt. 
- Was geschieht, wenn du die Gravitationskonstante auf Null setzt?
- Versuche, das Teilchen mit der Spur zu beschleunigen (oder zu bremsen), in dem du zu geeigneten Zeitpunkten die Gravitationskonstante hoch- und herunterschraubst. 

## RELATED MODELS

Alle die tollen Modelle im Gaslabor von NetLogo

## CREDITS AND REFERENCES

NetLogo: http://ccl.northwestern.edu/netlogo/
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270
@#$#@#$#@
NetLogo 6.3.0
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180
@#$#@#$#@
0
@#$#@#$#@
